/* 
	-- GarageSaleWidget.js
	-- GarageSaleWidget
	
	-- Created by Paul Hecker on 09.05.05
	-- Copyright (c) 2005 __MyCompanyName__. All rights reserved.
*/
var autoreloadInterval = 30000;
var timerInterval = null;
var flipShown = false; 
var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null}; 


if (window.widget) {
    widget.onhide = onhide;
    widget.onshow = onshow;
}

var scrollArea, scroller, doneButton, infoButton;

function setup() 
{
	scroller = new AppleVerticalScrollbar(document.getElementById("scroller"));
    scrollArea = new AppleScrollArea(document.getElementById("content"), scroller);
	scroller.setAutohide(false);
	updateTime();
	
	if (timerInterval == null)
        timerInterval = setInterval("updateTime();", autoreloadInterval);
		
	// version
	if (typeof(WindowScriptObject) == "undefined")
	{
		document.getElementById('versionString').innerHTML = "No WindowScriptObject available.";
	}
	else
	{
		document.getElementById('versionString').innerHTML = WindowScriptObject.getVersionString();
	}
	
	document.getElementById('Watchers').innerHTML = getLocalizedString('Watchers');
	document.getElementById('BidCount').innerHTML = getLocalizedString('Bid Count');
	document.getElementById('SoldQuantity').innerHTML = getLocalizedString('Sold/Quantity');
	document.getElementById('TimeRemaining').innerHTML = getLocalizedString('Time Remaining');
	
	// button
	doneButton = new AppleGlassButton(document.getElementById('done'), getLocalizedString('Done'), hidePrefs);
	infoButton = new AppleInfoButton(document.getElementById("fliprollie"), document.getElementById("front"), "black", "white", showPrefs);

	
	// load the size
	if (window.widget)
	{
		var width = widget.preferenceForKey (createKey('width'));
		var height = widget.preferenceForKey (createKey('height'));
		if ((width != null) && (height != null))
		{
			window.resizeTo(width, height);
		}
	}
	scroller.refresh();
	scrollArea.refresh();
}

function onshow() {
    if (timerInterval == null) {
		updateTime();
        timerInterval = setInterval("updateTime();", autoreloadInterval);
    }
}

function updateTime()
{
	if (typeof(WindowScriptObject) == "undefined")
	{
		var content = "<br>1<br>2<br>3<br>4<br>5<br>6<br>7<br>8<br>8<br>9<br>10<br>11<br><br><br><br>200<br>";
		document.getElementById('contentText').innerHTML = content;
		document.getElementById('lastUpdated').innerHTML = "";
	}
	else
	{
		document.getElementById('contentText').innerHTML = WindowScriptObject.getFrontContent();
		document.getElementById('contentText_TopBar').innerHTML = document.getElementById('contentText').innerHTML; // needed for Top Bar
		document.getElementById('lastUpdated').innerHTML = WindowScriptObject.getLastUpdated();
	}
	
	scroller.refresh();
	scrollArea.refresh();
}

function onhide() {
    if (timerInterval != null) {
        clearInterval(timerInterval);
        timerInterval = null;
    }
}

function mousemove (event) 
{ 
    if (!flipShown) 
    { 
        if (animation.timer != null) 
        { 
            clearInterval (animation.timer); 
            animation.timer  = null; 
        } 
        var starttime = (new Date).getTime() - 13; 
        animation.duration = 500; 
        animation.starttime = starttime; 
        animation.firstElement = document.getElementById ('fliprollie'); 
        animation.timer = setInterval ("animate();", 13); 
        animation.from = animation.now; 
        animation.to = 0.8; 
        animate(); 
        flipShown = true; 
    } 
} 

function mouseexit (event) 
{ 
    if (flipShown) 
    { 
        // fade in the info button 
        if (animation.timer != null) 
        { 
            clearInterval (animation.timer); 
            animation.timer  = null; 
        } 
        var starttime = (new Date).getTime() - 13; 
        animation.duration = 500; 
        animation.starttime = starttime; 
        animation.firstElement = document.getElementById ('fliprollie'); 
        animation.timer = setInterval ("animate();", 13); 
        animation.from = animation.now; 
        animation.to = 0.0; 
        animate(); 
        flipShown = false; 
    } 
} 

var lastPos;
function mouseDown(event)
{
	var x = event.x + window.screenX;
	var y = event.y + window.screenY;
	
	document.addEventListener("mousemove", mouseMove, true);
	document.addEventListener("mouseup", mouseUp, true);
	lastPos = {x:x, y:y};
	event.stopPropagation();
	event.preventDefault();
	scroller.refresh();
	scrollArea.refresh();
}
function mouseMove(event)
{
	var screenX = (event.x < 350 ? 350 : event.x) + window.screenX;
	var screenY = (event.y < 235 ? 235 : event.y) + window.screenY;
	
	window.resizeBy(screenX - lastPos.x, screenY - lastPos.y);
	
	lastPos = {x:screenX, y:screenY};
	event.stopPropagation();
	event.preventDefault();
	scroller.refresh();
	scrollArea.refresh();
}
function mouseUp(event)
{
    document.removeEventListener("mousemove", mouseMove, true);
    document.removeEventListener("mouseup", mouseUp, true); 
	
    event.stopPropagation();
    event.preventDefault();
	
	if (window.widget)
	{
		var width = window.innerWidth;
		var height = window.innerHeight;
		widget.setPreferenceForKey(width, createKey('width'));
		widget.setPreferenceForKey(height, createKey('height'));
	}
	scroller.refresh();
	scrollArea.refresh();
}

function showPrefs()
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");
	
    if (window.widget)
        widget.prepareForTransition("ToBack");
	
    front.style.display="none";
    back.style.display="block";
	
    if (window.widget)
        setTimeout ('widget.performTransition();', 0);
}

function hidePrefs()
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");
	
    if (window.widget)
        widget.prepareForTransition("ToFront");
	
    back.style.display="none";
    front.style.display="block";
	
    if (window.widget)
        setTimeout ('widget.performTransition();', 0);
}

// animate() performs the fade animation for the preferences flipper. It uses the opacity CSS property to simulate a fade.

function animate()
{
	var T;
	var ease;
	var time = (new Date).getTime();
	
	
	T = limit_3(time-animation.starttime, 0, animation.duration);
	
	if (T >= animation.duration)
	{
		clearInterval (animation.timer);
		animation.timer = null;
		animation.now = animation.to;
	}
	else
	{
		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
		animation.now = computeNextFloat (animation.from, animation.to, ease);
	}
	
	animation.firstElement.style.opacity = animation.now;
}


// these functions are utilities used by animate()

function limit_3 (a, b, c)
{
    return a < b ? b : (a > c ? c : a);
}

function computeNextFloat (from, to, ease)
{
    return from + (to - from) * ease;
}

// these functions are called when the info button itself receives onmouseover and onmouseout events

function enterflip(event)
{
	document.getElementById('fliprollie').style.display = 'block';
}

function exitflip(event)
{
	document.getElementById('fliprollie').style.display = 'none';
}

function clickOnProvider(event)
{
	if (window.widget)
		widget.openURL("http://www.iwascoding.com/GarageSale/");
}

function clickOnGarageSale(event)
{
	if (window.widget)
		widget.openApplication("com.iwascoding.garagesale");
}

function createKey(key)
{
	return widget.identifier + "-" + key;
}

function reloadEbayData(event)
{
	WindowScriptObject.reloadEbayData();	
	updateTime();
}

// animated reload button:
function showAnimatedReloadButton() 
{
	document.getElementById('AnimatedReloadButton').style.display = 'block';
    setTimeout("HIDEAnimatedReloadButton()", 1000);
}
function HIDEAnimatedReloadButton()
{ 
 	document.getElementById('AnimatedReloadButton').style.display = 'none';
}